//
//  AppDelegate.swift
//  HowManyWeeksLeft
//
//  Created by Justin Rhoades on 7/30/17.
//  Copyright © 2017 Justin Rhoades. All rights reserved.
//

import UIKit
import UserNotifications

@UIApplicationMain
class AppDelegate: UIResponder, UIApplicationDelegate {

    var window: UIWindow?
    var startAge: Int = 39
    var endAge: Int = 78
    var maxAge: Int = 110
    var numberOfWeeksLeft: Int!
    
    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplicationLaunchOptionsKey: Any]?) -> Bool {
        // Override point for customization after application launch.
        
        
        // Retrieve saved age values
        let defaults = UserDefaults.standard
        let startAgeSaved:Int = defaults.integer(forKey: "startAge")
        let endAgeSaved:Int = defaults.integer(forKey: "endAge")
        if startAgeSaved > 0 {
            startAge = startAgeSaved
        }
        if endAgeSaved > 0 {
            endAge = endAgeSaved
        }
        // Set the number of weeks
        numberOfWeeksLeft = 52 * (endAge - startAge)
        
        // Get permissionn for bading the app
        let center = UNUserNotificationCenter.current()
        let options: UNAuthorizationOptions = [.badge];
        center.requestAuthorization(options: options) {
            (granted, error) in
            if !granted {
                print("Something went wrong")
            }
        }
        
        //sendUpdateNotification()
        
        return true
    }
    
    func sendUpdateNotification() {
        let center = UNUserNotificationCenter.current()
        let content = UNMutableNotificationContent()
        content.badge = numberOfWeeksLeft - 1 as NSNumber
        let date = Date(timeIntervalSinceNow: 5)
        let triggerWeekly = Calendar.current.dateComponents([.weekday,.hour,.minute,.second,], from: date)
        let trigger = UNCalendarNotificationTrigger(dateMatching: triggerWeekly, repeats: true)
        let identifier = "UYLLocalNotification"
        let request = UNNotificationRequest(identifier: identifier, content: content, trigger: trigger)
        center.add(request, withCompletionHandler: { (error) in
            if let error = error {
                // Something went wrong
            }
        })
    }

    func applicationWillResignActive(_ application: UIApplication) {
        // Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
        // Use this method to pause ongoing tasks, disable timers, and invalidate graphics rendering callbacks. Games should use this method to pause the game.
    }

    func applicationDidEnterBackground(_ application: UIApplication) {
        // Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later.
        // If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
        
        // Save settings
        print(startAge, endAge)

        
        let defaults = UserDefaults.standard
        defaults.set(startAge, forKey: "startAge")
        defaults.set(endAge, forKey: "endAge")
    }

    func applicationWillEnterForeground(_ application: UIApplication) {
        // Called as part of the transition from the background to the active state; here you can undo many of the changes made on entering the background.
    }

    func applicationDidBecomeActive(_ application: UIApplication) {
        // Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
    }

    func applicationWillTerminate(_ application: UIApplication) {
        // Called when the application is about to terminate. Save data if appropriate. See also applicationDidEnterBackground:.
    }


}

