//
//  ArcView.swift
//  HowManyWeeksLeft
//
//  Created by Justin Rhoades on 03.08.17.
//  Copyright © 2017 Justin Rhoades. All rights reserved.
//

import UIKit

@IBDesignable

class ArcView: UIView {
    
    @IBInspectable var arcColor: UIColor = UIColor.white
    @IBInspectable var arcLineWidth: CGFloat = 9.0
    @IBInspectable var strokeStart: CGFloat = 0.2
    @IBInspectable var strokeEnd: CGFloat = 0.8


    let arc = CAShapeLayer()

    // Only override draw() if you perform custom drawing.
    // An empty implementation adversely affects performance during animation.
    
    override func draw(_ rect: CGRect) {
        
        
        let path = UIBezierPath(ovalIn:rect)
        
        arc.path = path.cgPath
        arc.fillColor = UIColor.clear.cgColor
        arc.strokeColor = arcColor.cgColor
        arc.strokeStart = strokeStart
        arc.strokeEnd = strokeEnd
        arc.lineWidth = arcLineWidth
        arc.lineCap = kCALineCapRound
        layer.addSublayer(arc)
        
        self.transform = CGAffineTransform(rotationAngle: CGFloat(Double.pi/2.0))
    }

        
    /*
    func addOval(lineWidth: CGFloat, path: CGPath, strokeStart: CGFloat, strokeEnd: CGFloat, strokeColor: UIColor, fillColor: UIColor, shadowRadius: CGFloat, shadowOpacity: Float, shadowOffsset: CGSize) {
        
        let arc = CAShapeLayer()
        arc.lineWidth = lineWidth
        arc.path = path
        arc.strokeStart = strokeStart
        arc.strokeEnd = strokeEnd
        arc.strokeColor = strokeColor.cgColor
        arc.fillColor = fillColor.cgColor
        arc.shadowColor = UIColor.black.cgColor
        arc.shadowRadius = shadowRadius
        arc.shadowOpacity = shadowOpacity
        arc.shadowOffset = shadowOffsset
        layer.addSublayer(arc)
    }
    
    override func draw(_ rect:CGRect) {
        // Add ARCs
        self.addCircle(arcRadius: self.bounds.width, capRadius: 20, color: self.arcColor)
    }
    
    func addCircle(arcRadius: CGFloat, capRadius: CGFloat, color: UIColor) {
        let X = self.bounds.midX
        let Y = self.bounds.midY
        
        // Bottom Oval
        let rect = CGRect(x:(X - (arcRadius/2)), y:(Y - (arcRadius/2)), width: arcRadius, height: arcRadius)
        let pathBottom = UIBezierPath(ovalIn:rect).cgPath
        self.addOval(lineWidth: 20.0, path: pathBottom, strokeStart: 0, strokeEnd: 0.5, strokeColor: color, fillColor: UIColor.clear, shadowRadius: 0, shadowOpacity: 0, shadowOffsset: CGSize.zero)
        
        // Middle Cap
        let weirdX = X - (capRadius/2) - (arcRadius/2)
        let rect2 = CGRect(x:weirdX, y:Y - (capRadius/2), width: capRadius, height: capRadius)
        let pathMiddle = UIBezierPath(ovalIn:rect2).cgPath
        self.addOval(lineWidth: 0.0, path: pathMiddle, strokeStart: 0, strokeEnd: 1.0, strokeColor: color, fillColor: color, shadowRadius: 5.0, shadowOpacity: 0.5, shadowOffsset: CGSize.zero)
        
        // Top Oval
        let rect3 = CGRect(x: X - (arcRadius/2), y: Y - (arcRadius/2), width: arcRadius, height: arcRadius)
        let pathTop = UIBezierPath(ovalIn:rect3).cgPath
        self.addOval(lineWidth: 20.0, path: pathTop, strokeStart: 0.5, strokeEnd: 1.0, strokeColor: color, fillColor: UIColor.clear, shadowRadius: 0, shadowOpacity: 0, shadowOffsset: CGSize.zero)
        
    }
     */

}
