//
//  IconChooserViewController.swift
//  HowManyWeeksLeft
//
//  Created by Justin Rhoades on 7/31/17.
//  Copyright © 2017 Justin Rhoades. All rights reserved.
//

import UIKit
import UserNotifications

class IconChooserViewController: UIViewController {
    
    @IBOutlet weak var optionAButton: UIButton!
    @IBOutlet weak var optionBButton: UIButton!
    @IBOutlet weak var iconASelectedBg: UIImageView!
    @IBOutlet weak var iconBSelectedBg: UIImageView!
    @IBOutlet weak var iconABadgeLabel: UILabel!
    @IBOutlet weak var iconBBadgeLabel: UILabel!
    @IBOutlet weak var iconAHighlight: UIImageView!
    @IBOutlet weak var iconBHighlight: UIImageView!
    
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let appDelegate = UIApplication.shared.delegate as! AppDelegate
        let weeksStr = String(appDelegate.numberOfWeeksLeft)

        let attributedString = NSMutableAttributedString(string: weeksStr)
        attributedString.addAttribute(NSAttributedStringKey.kern, value: CGFloat(1.0), range: NSRange(location: 0, length: attributedString.length))
        iconABadgeLabel.attributedText = attributedString
        iconBBadgeLabel.attributedText = attributedString

        iconABadgeLabel.layer.masksToBounds = true
        iconABadgeLabel.layer.cornerRadius = 10
        iconBBadgeLabel.layer.masksToBounds = true
        iconBBadgeLabel.layer.cornerRadius = 10
        
        // Set the default state
        iconASelectedBg.alpha = 1
        iconBSelectedBg.alpha = 0
        
        iconABadgeLabel.alpha = 1
        iconBBadgeLabel.alpha = 0
        
        iconAHighlight.alpha = 0.75
        iconBHighlight.alpha = 0.75
        
   }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    override var preferredStatusBarStyle: UIStatusBarStyle {
        return .lightContent
    }
    
    func onIconSelect() {
        
        /*
        let center = UNUserNotificationCenter.current()
        let identifier = "WeeksLeftBadgeUpdate"
        let content = UNMutableNotificationContent()
        content.badge = 900
        let trigger = UNTimeIntervalNotificationTrigger(timeInterval: 10, repeats: false)
        let request = UNNotificationRequest(identifier: identifier, content: content, trigger: trigger)
        center.add(request, withCompletionHandler: { (error) in
            if let error = error {
                // Something went wrong
                print(error)
            }
        })
         */
    
        Timer.scheduledTimer(withTimeInterval: 1.0, repeats: false) { (timer) in
            self.dismiss(animated: true, completion: nil)
        }
    }
    
    @IBAction func onIconOptionATap(_ sender: Any) {
        let animator:UIViewPropertyAnimator = UIViewPropertyAnimator(duration: 0.3, curve: .easeOut, animations: {
            self.iconASelectedBg.alpha = 1
            self.iconABadgeLabel.alpha = 1
            self.iconBSelectedBg.alpha = 0
            self.iconBBadgeLabel.alpha = 0
        })
        animator.addCompletion {
            _ in
            guard UIApplication.shared.supportsAlternateIcons else { return }
            UIApplication.shared.setAlternateIconName(nil) { err in
                if let err = err {
                    print("/!\\ Woops ! \(String(describing: err))")
                }
            }
        }
        animator.startAnimation()
    }
    
    @IBAction func onIconOptionBTap(_ sender: Any) {
        let animator:UIViewPropertyAnimator = UIViewPropertyAnimator(duration: 0.3, curve: .easeOut, animations: {
            self.iconBSelectedBg.alpha = 1
            self.iconBBadgeLabel.alpha = 1
            self.iconASelectedBg.alpha = 0
            self.iconABadgeLabel.alpha = 0
        })
        animator.addCompletion {
            _ in
            guard UIApplication.shared.supportsAlternateIcons else { return }
            UIApplication.shared.setAlternateIconName("AltIcon") { err in
                if let err = err {
                    print("/!\\ Woops ! \(String(describing: err))")
                }
            }
        }
        animator.startAnimation()
    }
    
    @IBAction func onIconATouchDown(_ sender: Any) {
        iconAHighlight.alpha = 1
    }
    
    @IBAction func onIconATouchUp(_ sender: Any) {
        UIView.animate(withDuration: 0.3) {
            self.iconAHighlight.alpha = 0.5
        }
        onIconSelect()
    }
    
    @IBAction func onIconBTouchDown(_ sender: Any) {
        iconBHighlight.alpha = 1
    }
    
    @IBAction func onIconBTouchUp(_ sender: Any) {
        UIView.animate(withDuration: 0.3) {
            self.iconBHighlight.alpha = 0.5
        }
        onIconSelect()
    }
    
    /*
    // MARK: - Navigation

    // In a storyboard-based application, you will often want to do a little preparation before navigation
    override func prepare(for segue: UIStoryboardSegue, sender: Any?) {
        // Get the new view controller using segue.destinationViewController.
        // Pass the selected object to the new view controller.
    }
    */

}
