//
//  StarfieldScene.swift
//  HowManyWeeksLeft
//
//  Created by Justin Rhoades on 12.08.17.
//  Copyright © 2017 Justin Rhoades. All rights reserved.
//

import UIKit
import SpriteKit
import CoreImage

class StarfieldScene: SKScene {
    
    var shaderNode = SKSpriteNode(imageNamed: "dummypixel")
    
    override func didChangeSize(_ oldSize: CGSize) {
        shaderNode.size = CGSize(width:UIScreen.main.bounds.width, height:UIScreen.main.bounds.height)
    }
    
    override func didMove(to view: SKView) {
        
        // Shader work with pixels, not points like we are used to on iOS. Store scale for use below.
        let scale = UIScreen.main.scale
        
        // Setup a container sprite for the shader
        // We are using an empty image in a sprite node because sprite nodes allow you to specify size and shader
        //shaderNode.position = CGPoint(x: 0, y: 0)
        
        
        // Create the shader from a starfieldShader02.fsh
//        let starfieldShader = SKShader(fileNamed: "starfieldShader02.fsh")
//        starfieldShader.uniforms = [
//            SKUniform(
//                name: "size",
//                vectorFloat3: vector_float3(Float(scale * UIScreen.main.bounds.width), Float(scale * UIScreen.main.bounds.height), 0)
//            ),
//        ]
//
        
        
        
        // Create the shader from a starfieldShader03.fsh
//        let starfieldShader = SKShader(fileNamed: "starfieldShader03.fsh")
//        starfieldShader.uniforms = [
//            SKUniform(
//                name: "size",
//                vectorFloat3: vector_float3(Float(scale * UIScreen.main.bounds.width), Float(scale * UIScreen.main.bounds.height), 0)
//            ),
//            SKUniform(
//                name: "fBrightness",
//                float: 2.5
//            ),
//            SKUniform(
//                name: "fSteps",
//                float: 121.0
//            ),
//            SKUniform(
//                name: "fParticleSize",
//                float: 0.015
//            ),
//            SKUniform(
//                name: "fParticleLength",
//                float: 0.5 / 60.0
//            ),
//            SKUniform(
//                name: "fMinDist",
//                float: 0.8
//            ),
//            SKUniform(
//                name: "fMaxDist",
//                float: 5.0
//            ),
//            SKUniform(
//                name: "fRepeatMin",
//                float: 1.0
//            ),
//            SKUniform(
//                name: "fRepeatMax",
//                float: 2.0
//            ),
//            SKUniform(
//                name: "fDepthFade",
//                float: 0.8
//            ),
//        ]

        
        // Create the shader from a starfieldShader04.fsh
        let starfieldShader = SKShader(fileNamed: "starfieldShader06.fsh")
        starfieldShader.uniforms = [
            SKUniform(
                name: "size",
                vectorFloat3: vector_float3(Float(scale * UIScreen.main.bounds.width), Float(scale * UIScreen.main.bounds.height), 0)
            ),
        ]

        //Add the shader to the sprite
        shaderNode.shader = starfieldShader
        
        //self.shouldEnableEffects = true
        //self.filter = CIFilter(name: "CIMotionBlur")
        
        addChild(shaderNode)
    }
}
