//
//  ViewController.swift
//  HowManyWeeksLeft
//
//  Created by Justin Rhoades on 7/30/17.
//  Copyright © 2017 Justin Rhoades. All rights reserved.
//

import UIKit
import SpriteKit

class StartViewController: UIViewController {
    
    @IBOutlet weak var spriteKitView: SKView!
    @IBOutlet weak var label: UILabel!
    @IBOutlet weak var labelTopConstraint: NSLayoutConstraint!
    @IBOutlet weak var nextButton: UIButton!
    @IBOutlet weak var resetBonesButton: UIButton!
    
    override func viewDidLoad() {
        super.viewDidLoad()

//        spriteKitView.showsFPS = true
//        spriteKitView.showsNodeCount = true
//        spriteKitView.showsPhysics = true
        
        //label.transform = CGAffineTransform(rotationAngle: CGFloat.pi / 2)
        //label.isHidden = true
        //let scene:BouncingWallsScene = spriteKitView.scene as! BouncingWallsScene
    }
    
    @IBAction func onRedoTap(_ sender: Any) {
        
        let scene:BouncingWallsScene = spriteKitView.scene as! BouncingWallsScene
        scene.redoBody()
        
        let rotationAnimationA = CABasicAnimation(keyPath: "transform.rotation")
        rotationAnimationA.fromValue = 0
        rotationAnimationA.toValue = .pi * 2.0
        rotationAnimationA.duration = 1.2
        rotationAnimationA.isCumulative = true
        rotationAnimationA.timingFunction = CAMediaTimingFunction(name:kCAMediaTimingFunctionEaseInEaseOut)
        rotationAnimationA.fillMode = kCAFillModeForwards
        rotationAnimationA.isRemovedOnCompletion = false
        resetBonesButton.layer.add(rotationAnimationA, forKey: "rotate")

    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    override var preferredStatusBarStyle: UIStatusBarStyle {
        return .lightContent
    }
    
    func prepViews() {
        label.alpha = 0
        //spriteKitView.alpha = 0
        nextButton.alpha = 0
        resetBonesButton.alpha = 0
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)        
        prepViews()
    }
    
    override func viewDidAppear(_ animated: Bool) {
        super.viewDidAppear(animated)
        
        let scene:BouncingWallsScene = spriteKitView.scene as! BouncingWallsScene
        scene.redoBody()
        
        UIView.animate(withDuration: 3.0, delay: 0, options:[.allowUserInteraction], animations: {
            self.label.alpha = 1.0
        }, completion: nil)
        
//        UIView.animate(withDuration: 3.0, delay: 1.0, options:[.curveEaseOut, .allowUserInteraction], animations: {
//            self.spriteKitView.alpha = 1.0
//        }, completion: nil)
        
        UIView.animate(withDuration: 3.0, delay: 2.0, options:[.allowUserInteraction], animations: {
            self.resetBonesButton.alpha = 1.0
        }, completion: nil)
        
        UIView.animate(withDuration: 1.0, delay: 2.0, options:[.curveEaseOut, .allowUserInteraction], animations: {
            self.nextButton.alpha = 1.0
        }, completion: nil)
        
        
    }
    
//    override var prefersStatusBarHidden: Bool {
//        return true
//    }



}

